'use strict';

const { Driver } = require('homey');
var server_data = new Array();
var serverActive = new Array();

class myIO_PWM_Driver extends Driver {
  
  async onInit() {
    for (var i = 1; i <= 10; i++) {
      var tempNrChar = "";
      if (i > 1) {
        tempNrChar = i.toString();
      }
      serverActive[i]=this.homey.settings.get('serverActive'+tempNrChar);
      if (serverActive[i] == "true") {
        const _i = i;
        const _tempNrChar = tempNrChar;
        setInterval(() => {            
          server_data[_i] = this.homey.settings.get('server_data' + _tempNrChar); 
        }, 2000);
      }
    }
    this.log('myIO_PWM_Driver has been initialized');
  }

  async onPairListDevices() {    
    var returnArray=[];
    var _serverID, key, number, i = 0;
    
    for (_serverID = 1; _serverID <= 10; _serverID++) {
      if (serverActive[_serverID] == "true") {
        for (key in server_data[_serverID]) {
          if (key == 'PWM' || key == 'PCA') {
            for (number = 0; number < Object.keys(server_data[_serverID][key]).length; number++) {
              var _actualKey = server_data[_serverID][key][number];
              if (_actualKey['description'] != '' && (_actualKey['pwm'] == 1 || key != 'PCA')) {
                returnArray[i] =
                {
                  name: _actualKey['description'],
                  data: { id: 'PWM_' + _actualKey['id']+'_'+_serverID},
                }
                i++;
              }
            }
          }
        }
      }
    }
    return returnArray;
  }
}

module.exports = myIO_PWM_Driver;
